=== debian/changelog ===
mlton (20210117+dfsg-3) unstable; urgency=medium

  * Replace build-depends-arch on mlton with mlton-compiler and mlton-tools to
    avoid pulling in mlton-doc
  * Drop version in mlton's recommends of mlton-doc
  * Make mlton-basis Arch: any instead of Arch: all. This avoids race
    conditions on buildds, where mlton-compiler sometimes became uninstallable
    if the new mlton-basis package got built before mlton-compiler on a given
    architecture, thereby making the previous version of mlton-compiler
    uninstallable. This then required manually rebootstrapping the
    architecture.
    + The build-indep target in debian/rules now only builds documentation
    + Drop 09_install-indep.diff, no longer needed
    + Transition versioned dependencies on mlton-basis from
      (= ${source:Version}) to (= ${binary:Version})

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 18:38:53 -0500

mlton (20210117+dfsg-2) unstable; urgency=medium

  * Move libgmp-dev to build-depends to fix binary-all builds
  * Drop dblatex build-dependency while we are not building the guide

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 13:37:28 -0500

mlton (20210117+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #992099)
  * Repack sources to remove non-DFSG files (Closes: #998156)
    + Extract and apply upstream patches to all nested tarballs while we are
      at it
    + Patch sources to handle missing non-DFSG-free files, 07_DFSG.diff
    + Disable installing mlnlffigen: it requires non-DFSG-free ckit-lib to build
  * Changes to patches:
    + Drop ppc64el.patch: applied upstream
    + Drop linux-pic.diff: no longer needed to successfully compile on amd64
    * Drop stack-hardening.diff: pass in flags via debian/rules instead
    + Rename patches to make application order obvious
    + Add DEP3 headers to all patches
  * Overhaul control file:
    + Move Homepage field from binary stanzas to source stanza
    + Use substvars to eliminate description duplication
    + Split Build-Depends into Build-Depends-Arch/Build-Depends-Indep
    + Drop alternative dependency on mlton-runtime, which has not existed
      since forever
    + Drop build-dependency on quilt and on procps
    + Drop breaks against mlton version now in oldoldoldstable
    + Added Vcs-* tags
    + Drop versioned Build-Depends-Arch on binutils and gcc for mips/mipsel:
      no longer needed
    + Set Rules-Requires-Root: no
    + Bump standards version to 4.6.0
  * Changes to documentation:
    + Updated README.Debian to reflect current mlton requirements
    + Added a README.source to describe repacking and bootstrapping process
  * Set myself as maintainer (Closes: #995467)
  * Documentation-related changes:
    + The mlton guide does not currently build. Temporarily disable building
      it for the sake of getting a working mlton compiler back in the archive
    + Temporarily disable installation of mllex and mlyacc guides
    + Documentation requires a build-dependency on python3-pygments instead of
      python-pygments (Closes: #943118)
    + Reintroduce build-dependency on dblatex
    + Install upstream changelog and readme.
  * Changes to package build process:
    + Switch from CDBS to debhelper
    + Set compat to 13 via debhelper-compat
    + Don't fetch resources from Github during build, 06_local_docs.diff
    + Remember to clean generated files under .cm/
    + Don't automatically run tests during build, 08_postpone_tests.diff
    + Add target to install arch-indep libraries, 09_install-indep.diff, and
      call it from rules
    + dh_missing should ignore
      - files for arch-dependent packages when building
        arch-independent packages
      - upstream license files usr/share/doc/mlton/license/*
  * Update copyright file and switch to DEP5 format

 -- Ryan Kavanagh <rak@debian.org>  Tue, 04 Jan 2022 09:12:48 -0500
