=== debian/control ===
Source: mlton
Section: devel
Priority: optional
Maintainer: Ryan Kavanagh <rak@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 libgmp-dev,
Build-Depends-Arch:
 dh-exec,
 mlton-compiler,
 mlton-tools,
Build-Depends-Indep:
 asciidoc,
 graphicsmagick,
 python3-pygments,
Homepage: http://mlton.org/
Standards-Version: 4.6.0
Description: Optimizing compiler for Standard ML
 MLton is a whole-program optimizing compiler for Standard ML.
 MLton generates standalone executables with excellent runtime
 performance, is SML 97 compliant, and has a complete basis
 library. MLton has source-level profiling, a fast C FFI, an
 interface to the GNU multiprecision library, and lots of useful
 libraries.
Vcs-Browser: https://salsa.debian.org/debian/mlton
Vcs-Git: https://salsa.debian.org/debian/mlton.git -b debian/unstable
Rules-Requires-Root: no

Package: mlton
Architecture: all
Multi-Arch: foreign
Depends:
 mlton-compiler (<< ${source:Version}.1~),
 mlton-compiler (>= ${source:Version}),
 mlton-tools (<< ${source:Version}.1~),
 mlton-tools (>= ${source:Version}),
 ${misc:Depends},
Recommends:
 mlton-doc
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This metapackage depends on all MLton packages.

Package: mlton-basis
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - basis library
 ${source:Extended-Description}
 .
 This package includes the cross-platform basis.

Package: mlton-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package includes non-man-page documentation.

Package: mlton-compiler
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 gcc,
 libc6-dev,
 libgmp-dev,
 mlton-basis (= ${binary:Version}),
 mlton-runtime-native (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - compiler
 ${source:Extended-Description}
 .
 This package includes the compiler itself.

Package: mlton-tools
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - tools
 ${source:Extended-Description}
 .
 This package includes tools which autogenerate SML.

Package: mlton-runtime-native
Architecture: alpha amd64 arm64 armel armhf hppa i386 kfreebsd-amd64 kfreebsd-i386 mips mips64el mipsel powerpc ppc64el riscv64 s390x sparc
Depends:
 mlton-runtime-alpha-linux-gnu (= ${binary:Version}) [alpha] | mlton-runtime-x86-64-linux-gnu (= ${binary:Version}) [amd64] | mlton-runtime-aarch64-linux-gnu (= ${binary:Version}) [arm64] | mlton-runtime-arm-linux-gnueabi (= ${binary:Version}) [armel] | mlton-runtime-arm-linux-gnueabihf (= ${binary:Version}) [armhf] | mlton-runtime-hppa-linux-gnu (= ${binary:Version}) [hppa] | mlton-runtime-i486-linux-gnu (= ${binary:Version}) [i386] | mlton-runtime-i486-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-i386] | mlton-runtime-x86-64-kfreebsd-gnu (= ${binary:Version}) [kfreebsd-amd64] | mlton-runtime-mips64el-linux-gnuabi64 (= ${binary:Version}) [mips64el] | mlton-runtime-mips-linux-gnu (= ${binary:Version}) [mips] | mlton-runtime-mipsel-linux-gnu (= ${binary:Version}) [mipsel] | mlton-runtime-powerpc-linux-gnu (= ${binary:Version}) [powerpc] | mlton-runtime-powerpc64le-linux-gnu (= ${binary:Version}) [ppc64el] | mlton-runtime-s390x-linux-gnu (= ${binary:Version}) [s390x] | mlton-runtime-sparc-linux-gnu (= ${binary:Version}) [sparc],
 ${misc:Depends},
Description: ${source:Synopsis} - native runtime libraries
 ${source:Extended-Description}
 .
 This metapackage depends on native target libraries.

Package: mlton-runtime-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-aarch64-linux-gnu
Architecture: arm64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabi
Architecture: armel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-arm-linux-gnueabihf
Architecture: armhf
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-hppa-linux-gnu
Architecture: hppa
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-i486-linux-gnu
Architecture: i386
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-i486-kfreebsd-gnu
Architecture: kfreebsd-i386
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-x86-64-kfreebsd-gnu
Architecture: kfreebsd-amd64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips64el-linux-gnuabi64
Architecture: mips64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mips-linux-gnu
Architecture: mips
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-mipsel-linux-gnu
Architecture: mipsel
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc-linux-gnu
Architecture: powerpc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-powerpc64le-linux-gnu
Architecture: ppc64el
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-riscv64-linux-gnu
Architecture: riscv64
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-s390x-linux-gnu
Architecture: s390x
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.

Package: mlton-runtime-sparc-linux-gnu
Architecture: sparc
Multi-Arch: foreign
Depends:
 mlton-basis (= ${binary:Version}),
 ${misc:Depends},
Provides:
 mlton-runtime,
Description: ${source:Synopsis} - ${Arch} runtime libraries
 ${source:Extended-Description}
 .
 This package provides ${Arch} target libraries.
