=== debian/watch ===
# Compulsory line, this is a version 4 file
version=4

# GitHub hosted projects
opts="dversionmangle=s/\+dfsg\d*$//, \
      mode=git, gitmode=full, pgpmode=none" \
   https://github.com/MLton/mlton/ \
   refs/tags/on-@ANY_VERSION@-release
